#include <stdio.h>
#include <windows.h>
#include <comdef.h>

#include "runtime.h"
#include "Transition1AUT/common.h"

//    
#import "../VisualPart.vb/Mark4.exe"
Mark4::_Mark4VisualisationPtr pM4Visualisation;

//      
WarmerPlateStatus GetWarmerPlateStatus()
{
    return( ( WarmerPlateStatus )pM4Visualisation->GetWarmerPlateStatus() );
}

BoilerStatus GetBoilerStatus()
{
    return( ( BoilerStatus )pM4Visualisation->GetBoilerStatus() );
}

BrewButtonStatus GetBrewButtonStatus()
{
    return( ( BrewButtonStatus )pM4Visualisation->GetBrewButtonStatus() );
}

void SetBoilerState(BoilerHeaterState s)
{
    long uS = (long)s;
    pM4Visualisation->SetBoilerState( &uS );
}

void SetWarmerState(WarmerState s)
{
    long uS = (long)s;
    pM4Visualisation->SetWarmerState( &uS );
}

void SetIndicatorState(IndicatorState s)
{
    long uS = (long)s;
    pM4Visualisation->SetIndicatorState( &uS );
}

void SetReliefValveState(ReliefValveState s)
{
    long uS = (long)s;
    pM4Visualisation->SetReliefValveState( &uS );
}

DWORD WINAPI AutomateThread( void* pId )
{
    DWORD* pMainThreadId = (DWORD*) pId;

    CoInitialize( 0 );

    HRESULT hErr = pM4Visualisation.CreateInstance( __uuidof( Mark4::Mark4Visualisation ) );
    if ( ERROR_SUCCESS != hErr )
    {
        printf( "Error %i: create instance", hErr );
        PostThreadMessage( *pMainThreadId, WM_QUIT, 1, 0 );
        return( 1 );
    }


    while ( true )
    {
        if ( false == pM4Visualisation->FormAlive() )
        {
            pM4Visualisation.Release();
            CoUninitialize();

            PostThreadMessage( *pMainThreadId, WM_QUIT, 0, 0 );
            return( 0 );
        }
        
        try
        {
            //  
            WarmerPlateStatus eWarmerStatus      = GetWarmerPlateStatus();
            BoilerStatus      eBoilerStatus      = GetBoilerStatus();
            BrewButtonStatus  eBrewButtonStatus  = GetBrewButtonStatus();

            if ( eWarmerStatus == potEmpty && eBoilerStatus == boilerNotEmpty && eBrewButtonStatus == brewButtonPushed )
            {
                A0( 10 );
            }

            if ( eBoilerStatus == boilerEmpty )
            {
                A0( 20 );
            }

            if ( eWarmerStatus == warmerEmpty )
            {
                A0( 30 );
            }

            if ( eWarmerStatus == potEmpty )
            {
                A0( 31 );
            }

            if ( eWarmerStatus == potNotEmpty )
            {
                A0( 32 );
            }
            /////////////////////
        }
        catch( _com_error cErr )
        {
            pM4Visualisation.Release();
            CoUninitialize();

            PostThreadMessage( *pMainThreadId, WM_QUIT, 1, 0 );
            return( 1 );
        }
        
        Sleep( 20 );    
    }
}

int main( int argc, char** argv )
{
    DWORD   uMainThreadId       = GetCurrentThreadId();
    DWORD   uAutomateThreadId   = 0;
    HANDLE  hAutomateThread     = CreateThread( 0, 0, &AutomateThread, &uMainThreadId, 0, &uAutomateThreadId );
    
    MSG     sMessage;
    BOOL    bResult;
    while( 0 != (bResult = GetMessage( &sMessage, NULL, 0, 0 )) )
    {        
        TranslateMessage( &sMessage );
        DispatchMessage( &sMessage );
    }

    return( sMessage.wParam );
}