#include "coffeeMaker.h"
#include "sprayer.h"
#include "warmer.h"
#include "ui.h"

CoffeeMaker::CoffeeMaker()
: itsSprayer(0)
, itsWarmer(0)
, itsUI(0)
{}

CoffeeMaker::~CoffeeMaker() {}

int CoffeeMaker::CheckReady()
{
    return itsWarmer->CheckReady() && itsSprayer->CheckReady();
}

void CoffeeMaker::Brew()
{
    itsWarmer->Brew();
    itsSprayer->Brew();
}

void CoffeeMaker::BrewingComplete()
{
    itsUI->BrewingComplete();
    itsWarmer->BrewingComplete();
}

void CoffeeMaker::Pot()
{
    itsSprayer->Pot();
}

void CoffeeMaker::NoPot()
{
    itsSprayer->NoPot();
}

void CoffeeMaker::CycleComplete()
{
    itsUI->CycleComplete();
}


