#ifndef COFFEEMAKER_COFFEEMAKER_H
#define COFFEEMAKER_COFFEEMAKER_H

class UI;
class Sprayer;
class Warmer;

#include "sprayerClient.h"
#include "uiClient.h"
#include "warmerClient.h"

class CoffeeMaker : public SprayerClient,
                    public WarmerClient,
                    public UIClient
{
  public:
    CoffeeMaker();
    virtual ~CoffeeMaker();
    
    // UIClient
    virtual int CheckReady();
    virtual void Brew();

    // SprayerClient
    virtual void BrewingComplete();

    // WarmerClient
    virtual void Pot();
    virtual void NoPot();
    virtual void CycleComplete();

    void SetUI(UI& theUI)                {itsUI = &theUI;}
    void SetSprayer(Sprayer& theSprayer) {itsSprayer = &theSprayer;}
    void SetWarmer(Warmer& theWarmer)    {itsWarmer = &theWarmer;}
    
  private:
    UI*      itsUI;
    Warmer*  itsWarmer;
    Sprayer* itsSprayer;
};
#endif
