#include "m4Sprayer.h"
#include "sprayerClient.h"
#include "sprayerDriver.h"

MarkIV_Sprayer::MarkIV_Sprayer(SprayerDriver& theDriver,
			       SprayerClient& theClient)
: Sprayer(theDriver, theClient)
, itsState(notBrewing)
{GetDriver().StopSpray();}

MarkIV_Sprayer::~MarkIV_Sprayer() {}

int MarkIV_Sprayer::CheckReady()
{
    return GetDriver().HasWater();
}

void MarkIV_Sprayer::Poll()
{
    if (!GetDriver().HasWater())
    {
	BrewingComplete();
    }
}

void MarkIV_Sprayer::Pot()
{
    switch (itsState)
    {
    case notBrewing:   /* ignore */ break;
    case spraying:     /* ignore */ break;
    case brewingNoPot: itsState=spraying;
	               GetDriver().Spray(); break;
    }
}

void MarkIV_Sprayer::NoPot()
{
    switch (itsState)
    {
    case notBrewing:   /* ignore */ break;
    case spraying:     itsState=brewingNoPot;
	               GetDriver().StopSpray(); break;
    case brewingNoPot: /* ignore */ break;
    }
}

void MarkIV_Sprayer::Brew()
{
    switch (itsState)
    {
    case notBrewing:   itsState=spraying;
	               GetDriver().Spray(); break;
    case spraying:     /* ignore */ break;
    case brewingNoPot: /* ignore */ break;
    }
}

void MarkIV_Sprayer::BrewingComplete()
{
    switch (itsState)
    {
    case notBrewing:   /* ignore */ break;
    case spraying:     itsState=notBrewing;
	               GetDriver().StopSpray();
		       GetClient().BrewingComplete(); break;
    case brewingNoPot: itsState=notBrewing;
		       GetClient().BrewingComplete(); break;
    }
}
