#ifndef MARKIV_M4SPRAYER_H
#define MARKIV_M4SPRAYER_H

#include "sprayer.h"

//-------------------------------------------------------
// Name
//  MarkIV_Sprayer
//
// Description
//  This class implements the control model for the MarkIV
//  Sprayer.
//
class MarkIV_Sprayer : public Sprayer
{
  public:
    MarkIV_Sprayer(SprayerDriver&, SprayerClient&);
    virtual ~MarkIV_Sprayer();
    
    virtual int CheckReady();
    void Poll();

    // External Stimuli
    virtual void Pot();
    virtual void NoPot();
    virtual void Brew();

    // FSM Events
    void BrewingComplete();

  private:
    enum SprayerState {notBrewing, spraying, brewingNoPot} itsState;
};
#endif
