#ifndef MARKIV_M4WARMER_H
#define MARKIV_M4WARMER_H

#include "warmer.h"

//------------------------------------------------
// Name
//  MarkIV_Warmer
//
// Description
//  This class implements the control model for the
//  Warmer system of the MarkIV Coffee Maker.
//
class MarkIV_Warmer : public Warmer
{
  public:
    MarkIV_Warmer(WarmerDriver&, WarmerClient&);
    virtual ~MarkIV_Warmer();

    // External Stimuli
    virtual void Brew();
    virtual void BrewingComplete();
    virtual int  CheckReady();

    // FSM Events
    void PotEmpty();
    void PotNotEmpty();
    void WarmerEmpty();

    // Couple to main program
    void Poll();
    
  private:
    enum M4WarmerState
    {
	notBrewing, brewingPotEmpty, brewingWarming, emptyPotRemoved,
	fullPotRemoved, brewingComplete, brewedPotRemoved
    } itsState;
};
#endif
