#include "markIV_UI.h"
#include "uiClient.h"
#include "uiDriver.h"

MarkIV_UI::MarkIV_UI(UIDriver& theDriver, UIClient& theClient)
: UI(theDriver, theClient)
, itsState(notBrewing)
{GetDriver().IndicateReady();}

MarkIV_UI::~MarkIV_UI() {}

void MarkIV_UI::Start()
{
    switch (itsState)
    {
    case notBrewing: itsState=checkingReadiness; CheckReady(); break;
    case checkingReadiness: /* ignore */ break;
    case brewing: /* ignore */ break;
    case doneBrewing: /* ignore */ break;
    };
}

void MarkIV_UI::Ready()
{
    switch (itsState)
    {
    case notBrewing: /* ignore */ break;
    case checkingReadiness: itsState = brewing; GetClient().Brew(); break;
    case brewing: /* ignore */ break;
    case doneBrewing: /* ignore */ break;
    };
}

void MarkIV_UI::NotReady()
{
    switch (itsState)
    {
    case notBrewing: /* ignore */ break;
    case checkingReadiness: itsState = notBrewing; break;
    case brewing: /* ignore */ break;
    case doneBrewing: /* ignore */ break;
    };
}

void MarkIV_UI::BrewingComplete()
{
    switch (itsState)
    {
    case notBrewing: /* ignore */ break;
    case checkingReadiness: itsState = notBrewing; break;
    case brewing:
	itsState = doneBrewing;
	GetDriver().IndicateCompletion();
	break;
    case doneBrewing: /* ignore */ break;
    };
}

void MarkIV_UI::CycleComplete()
{
    switch(itsState)
    {
    case notBrewing: /* ignore */ break;
    case checkingReadiness: itsState = notBrewing; break;
    case brewing: itsState = notBrewing; break;
    case doneBrewing:
	itsState = notBrewing; GetDriver().IndicateReady(); break;
    }
}

void MarkIV_UI::CheckReady()
{
    if (GetClient().CheckReady())
    {
	Ready();
    }
    else
    {
	NotReady();
    }
}

void MarkIV_UI::Poll()
{
    if (itsState == notBrewing && GetDriver().CheckStart()) // user has started
    {
	Start();
    }
}

