#ifndef MARKIV_MARKVI_UI_H
#define MARKIV_MARKIV_UI_H

#include "ui.h"

//----------------------------------------------------------
// Name
//  MarkIV_UI
//
// Description
//  This class implements control model of the User Interface
//  for the MarkIV coffee Maker.
//
class MarkIV_UI : public UI
{
  public:
    MarkIV_UI(UIDriver& theDriver, UIClient& theClient);
    virtual ~MarkIV_UI();

    // External Stimuli
    virtual void BrewingComplete();
    virtual void CycleComplete();

    // FSM Events.
    void Start();
    void Ready();
    void NotReady();

    // Gain control from main program
    void Poll();

  private:
    // Utility functions
    void CheckReady();
    
    enum {notBrewing, checkingReadiness, brewing, doneBrewing} itsState;
};
#endif
