#ifndef SPRAYER_SPRAYER_DRIVER_H
#define SPRAYER_SPRAYER_DRIVER_H

//----------------------------------------
// Name
//  SprayerDriver
//
// Description
//  This class presents the interface for the device
//  which sprays hot water over the coffee grounds in
//  a coffee maker.  A sprayer can be told to do two things.
//  It can be told to start spraying, and to stop spraying.
//  A sprayer driver can also be asked if water is available
//  for spraying.
//
class SprayerDriver
{
  public:
    virtual void Spray() = 0;
    virtual void StopSpray() = 0;
    virtual int  HasWater() = 0;
};
#endif
