#ifndef UI_UI_H
#define UI_UI_H

class UIClient;
class UIDriver;

//---------------------------------------------------
// Name
//  UI
//
// Description
//  This class is the abstract interface for the Coffee
//  Maker user interface.  It knows about UI Clients and
//  the driver for the UI hardware.  It allows external
//  classes to inform it of the status of the brewing
//  cycle.
//
class UI
{
  public:
    UI(UIDriver& theDriver, UIClient& theClient);
    virtual ~UI();

    // External Stimuli.
    virtual void BrewingComplete() = 0;
    virtual void CycleComplete() = 0;
    
  protected:
    UIDriver& GetDriver() {return itsDriver;}
    UIClient& GetClient() {return itsClient;}
    
  private:
    UIDriver& itsDriver;
    UIClient& itsClient;
};
#endif
