#ifndef UI_UI_DRIVER
#define UI_UI_DRIVER

//---------------------------------------------------
// Name
//  UIDriver
//
// Description
//  This class presents the interface for all UI Hardware
//  drivers.  The UI hardware can be told to tell the user
//  that brewing is complete or to tell the user that the coffee
//  maker is ready to brew.  It can also poll the user to see if
//  he started a brewing cycle.
//
class UIDriver
{
  public:
    virtual void IndicateCompletion() = 0;
    virtual void IndicateReady()      = 0;
    virtual int  CheckStart()         = 0;
};
#endif



