#ifndef WARMER_WARMER_H
#define WARMER_WARMER_H

class WarmerClient;
class WarmerDriver;

//-----------------------------------------------
// Name
//  Warmer
//
// Description
//  This class presents the interface for the Warmer of
//  a coffee maker.  It can be asked if it is ready to start
//  brewing, and it can be told that brewing is complete.
//
class Warmer
{
  public:
    Warmer(WarmerDriver& theDriver, WarmerClient& theClient);
    virtual ~Warmer();

    // External Stimuli
    virtual void Brew() = 0;
    virtual void BrewingComplete() = 0;
    virtual int  CheckReady() = 0;

  protected:
    WarmerDriver& GetDriver() {return itsDriver;}
    WarmerClient& GetClient() {return itsClient;}

  private:
    WarmerDriver& itsDriver;
    WarmerClient& itsClient;
};
#endif
