#ifndef WARMER_WARMER_CLIENT_H
#define WARMER_WARMER_CLIENT_H

//-------------------------------------------
// Name
//  WarmerClient
//
// Description
//  This class presents the interface for all clients of
//  a coffee maker warmer.  WarmerClients can be told of the
//  presence or absence of a pot, and whether or not the
//  cycle has completed.  CycleComplete means that an empty pot
//  has been put on the warmer after having brewed coffee.
//
class WarmerClient
{
  public:
    virtual void Pot() = 0;
    virtual void NoPot() = 0;
    virtual void CycleComplete() = 0;
};
#endif
