#ifndef WARMER_WARMER_DRIVER_H
#define WARMER_WARMER_DRIVER_H

//-------------------------------------------------
// Name
//  WarmerDriver
//
// Description
//  This class presents the generic interface
//  for the hardware driver of a warmer plate.
//
//  A warmer plate can be turned on or off.  It can
//  also be queried as the the presence and status
//  of a pot.
//
class WarmerDriver
{
  public:
    enum WarmerStatus {noPot, potEmpty, potNotEmpty};

    virtual void WarmerOn() = 0;
    virtual void WarmerOff() = 0;
    virtual WarmerStatus GetWarmerStatus() = 0;
};
#endif
